import { getModelForClass, index, modelOptions, prop } from '@typegoose/typegoose'
import { dbconn } from '../decorators/dbconn'

@dbconn()
@modelOptions({ schemaOptions: { collection: 'id_counter', _id: false } })
class IDCounterClass {
  @prop()
  public _id: string
  @prop({ default: 1 })
  public seq: number
  static nextCount() {
    return IDCounter.findOneAndUpdate(
      { _id: 'userShortId' },
      { $inc: { seq: 1 } },
      {
        upsert: true,
        new: true,
        setDefaultsOnInsert: true,
      },
    )
  }
  static nextID(id: string) {
    return IDCounter.findOneAndUpdate(
      { _id: id },
      { $inc: { seq: 1 } },
      {
        upsert: true,
        new: true,
        setDefaultsOnInsert: true,
      },
    )
  }
}

export const IDCounter = getModelForClass(IDCounterClass, { existingConnection: IDCounterClass['db'] })
