import { ChainCache } from 'cache/ChainCache'
import { BlockChain } from 'chain/BlockChain'
import { singleton } from 'decorators/singleton'
import * as schedule from 'node-schedule'

@singleton
export default class BlocknumSchedule {
  parseAllRecord() {
    for (let cfg of new ChainCache().chainArray) {
      new BlockChain().updateCurrenBlockNum(cfg.id)
    }
  }
  scheduleAll() {
    const job = schedule.scheduleJob('*/5 * * * * *', async () => {
      await this.parseAllRecord()
    })
  }
}
