import logger from 'logger/logger'
import { ChainTask } from 'models/ChainTask'
import { RequestTask } from 'models/RequestTask'
import { ChainQueue } from 'queue/chain.queue'
import { ExecQueue } from 'queue/exec.queue'

export async function restartAllUnFinishedTask() {
  let chainTasks = await ChainTask.allUnFinishedTask()
  logger.info(`restore ${chainTasks.length} chain tasks`)
  let chainQueue = new ChainQueue()
  let execQueue = new ExecQueue()
  for (let cTask of chainTasks) {
    let subTasks = await RequestTask.allUnFinishedTask(cTask.id)
    logger.info(`restore ${subTasks.length} req tasks fro ${cTask.id}`)
    for (let subTask of subTasks) {
      chainQueue.addTaskToQueue(subTask)
      execQueue.addTaskToQueue(subTask)
    }
  }
}
