import { MAX_BATCH_REQ_COUNT } from 'common/Constants'
import xlsx from 'node-xlsx'

export function excelToJson(filePath: string) {
  console.log('excel2json: ' + filePath)
  const workSheetsFromFile = xlsx.parse(filePath)
  if (!workSheetsFromFile || workSheetsFromFile.length === 0) {
    throw new Error('excelToJson: no sheet found')
  }
  const sheet = workSheetsFromFile[0]
  const header = (sheet.data[0] as string[]).map(item => item.toLowerCase())
  let arr = []
  for (let i = 1, l = sheet.data.length; i < l; i++) {
    let row = sheet.data[i] as []
    if (row.length === 0) {
      continue
    }
    let obj = {}
    for (let j = 0, k = header.length; j < k; j++) {
      obj[header[j]] = header[j] === 'type' ? row[j] | 0 : row[j]
    }
    arr.push(obj)
  }
  return arr
}

export function groupNftMintData(datas: any[]) {
  let dataMap = new Map()
  let results: any[] = []
  for (let data of datas) {
    if (dataMap.has(data.to)) {
      let tempData = dataMap.get(data.to)
      if (tempData.tokenIds.length >= MAX_BATCH_REQ_COUNT) {
        results.push(tempData)
        data.tokenIds = [data.tokenid || data.tokenId]
        dataMap.set(data.to, data)
      } else {
        tempData.tokenIds.push(data.tokenid || data.tokenId)
      }
    } else {
      data.tokenIds = [data.tokenid || data.tokenId]
      dataMap.set(data.to, data)
    }
  }
  results = results.concat([...dataMap.values()])
  return results
}
