import { IDCounter } from 'models/IDCounter'

export const ONE_DAY = 24 * 60 * 60 * 1000
export const NFT_BEGIN_DAY = new Date(2023, 4, 8)

// calc days between two Date
export function daysBetween(date1: Date, date2: Date) {
  // hours*minutes*seconds*milliseconds
  const diffInMs = Math.abs(date1.getTime() - date2.getTime())
  const diffInDays = Math.round(diffInMs / ONE_DAY)
  return diffInDays
}

/**
 * 生成nft的tokenid
 * 规则:
 *    100       9999                   00       0000001
 *    NFT类型   当前日期至开始日期的天数   渠道编号  当前类型的序号
 */
export async function generateNftID(nfttype: number, channel: number) {
  const days = daysBetween(new Date(), NFT_BEGIN_DAY)
  const dayKey = (days + '').padStart(4, '0')
  const channelKey = (channel + '').padStart(2, '0')
  const idkey = nfttype + dayKey + channelKey
  const idobj = await IDCounter.nextID(idkey)
  const val = (idobj.seq + '').padStart(7, '0')
  return idkey + val
}
